" ------------------------------------------------------------------- "
" TextTags Class is a Singleton class that allows the user            "
" to reference Text DataType tags' hexadecimal values.                "
""
" The User does NOT need to create one of these, since DataTypeSystem "
" Class will instantiate the only needed instance of this Class.  See "
" the DataTypeSystem.st source file for the method(s) that help the   "
" User with this Class.                                               "
""
" ALL singleton classes MUST contain the following:                   "
""
"   the methods:  isSingleton AND privateSetup     AND                "
"                 uniqueInstance Class instance variable.             "
" ------------------------------------------------------------------- "

Class TextTags :Dictionary ! uniqueInstance !
[
   isSingleton
     ^ true  
|  
   privateNew ! newinstance !
     newinstance <- super new.

     ^ newinstance
|
   new
     ^ self privateSetup
|
   privateSetup
     (uniqueInstance isNil)
       ifTrue: [uniqueInstance <- self privateNew.

                "Text attributes:"
                self at: #TDTA_Buffer      put: 16r8000112C.
                self at: #TDTA_BufferLen   put: 16r8000112D.
                self at: #TDTA_LineList    put: 16r8000112E.
                self at: #TDTA_WordSelect  put: 16r8000112F.
                self at: #TDTA_WordDelim   put: 16r80001130.
                self at: #TDTA_WordWrap    put: 16r80001131.

                "Line Feed:"
                self at: #LNF_LF           put: 1.

                "Segment is a link:"
                self at: #LNF_LINK         put: 2.

                "ln_Data is a pointer to an DataTypes object:"
                self at: #LNF_OBJECT       put: 4.

                "Object is selected:"
                self at: #LNF_SELECTED     put: 8
               ].
               
     ^ self    "or ^ uniqueInstance??"
]
