"------------------------------------------------------------------"
" Icon Class implements control of Amiga Workbench Icons           "
" Chances are that Glyph is the wrong parent class for this class. "
"------------------------------------------------------------------"

Class Icon :Glyph ! private iconName !
[
   editToolTypes ! temp !
      temp <- <primitive 219 2 iconName>.
      
      (temp ~= true)
         ifTrue: ['ToolTypesEditor NOT found!' print]
|      
   displayIconInfo ! temp !
      temp <- <primitive 219 3 private iconName>.
      
      (temp ~= nil)
        ifTrue: ['Method displayIconInfo returned', temp print]
|
   displayIconImages
      <primitive 219 4 private iconName>
|
   setIconPosition: newPoint ! nx ny chk !
      nx  <- newPoint x.
      ny  <- newPoint y. 
      chk <- <primitive 219 5 private iconName nx ny>.

      (chk ~= nil)
         ifTrue: ['Method setIconPosition returned ', chk print]
|
   moveIcon: deltaPoint ! dx dy chk !
      dx  <- deltaPoint x.
      dy  <- deltaPoint y. 
      chk <- <primitive 219 6 private iconName dx dy>.

      (chk ~= nil)
         ifTrue: ['Method moveIcon returned ', chk print]
|
   editIcon: externalEditorName
      (<primitive 219 7 iconName externalEditorName> ~= true)
         ifTrue: ['Method editIcon: ',externalEditorName, 'did NOT run!' print]
|
   addToolType: toolString
      (<primitive 219 8 private iconName toolString> == false)
        ifTrue: ['ToolType ', toolString, 'NOT added!' print]
|
   deleteToolType: toolString
      (<primitive 219 9 private iconName toolString> == false)
        ifTrue: ['ToolType ', toolString, 'NOT deleted!' print]
|
   getIconWidth
      ^ <primitive 219 10 private>
|
   getIconHeight
      ^ <primitive 219 11 private>
|
   getIconFlags
      ^ <primitive 219 12 private>
|
   getIconImageObject
      ^ <primitive 219 13 private>
|
   getIconAlternateImageObject
      ^ <primitive 219 14 private>
|
   getIconType
      "  Valid types are:

         WBDISK     = 1
         WBDRAWER   = 2
         WBTOOL     = 3
         WBPROJECT  = 4
         WBGARBAGE  = 5
         WBDEVICE   = 6
         WBKICK     = 7
         WBAPPICON  = 8
      "
      ^ <primitive 219 15 private>
|
   getDefaultTool
      ^ <primitive 219 16 private>
|
   getStackSize
      ^ <primitive 219 17 private>
|
   getWindowWidth
      ^ <primitive 219 18 private>
|
   getWindowHeight
      ^ <primitive 219 19 private>
|
   getWindowTopEdge
      ^ <primitive 219 20 private>
|
   getWindowLeftEdge
      ^ <primitive 219 21 private>
|
   setIconWidth: newWidth
      (<primitive 219 22 private iconName newWidth> ~= true)
         ifTrue: ['Method setIconWidth: ', newWidth, ' failed!' print]
|
   setIconHeight: newHeight
      (<primitive 219 23 private iconName newHeight> ~= true)
         ifTrue: ['Method setIconHeight: ', newHeight, ' failed!' print]
|
   setIconFlags: newFlags
      (<primitive 219 24 private iconName newFlags> ~= true)
         ifTrue: ['Method setIconFlags: ', newFlags, ' failed!' print]
|
   setIconImage: imageObject
      (<primitive 219 25 private iconName imageObject> ~= true)
         ifTrue: ['Method setIconImage: failed!' print]
|
   setIconAlternateImage: imageObject
      (<primitive 219 26 private iconName imageObject> ~= true)
         ifTrue: ['Method setIconAlternateImage: failed!' print]
|
   setIconType: newType
      "  Valid types are:

         WBDISK     = 1
         WBDRAWER   = 2
         WBTOOL     = 3
         WBPROJECT  = 4
         WBGARBAGE  = 5
         WBDEVICE   = 6
         WBKICK     = 7
         WBAPPICON  = 8
      "
      (<primitive 219 27 private iconName newType> ~= true)
         ifTrue: ['Method setIconType: ', newType, ' failed!' print]
|
   setDefaultTool: newDefaultTool
      (<primitive 219 28 private iconName newDefaultTool> ~= true)
         ifTrue: ['Method setDefaultTool: ', newDefaultTool, ' failed!' print]
|
   setStackSize: newStackSize
      (<primitive 219 29 private iconName newStackSize> ~= true)
         ifTrue: ['Method setStackSize: ', newStackSize, ' failed!' print]
|
   setWindowWidth: newWidth
      (<primitive 219 30 private iconName newWidth> ~= true)
         ifTrue: ['Method setWindowWidth: ', newWidth, ' failed!' print]
|
   setWindowHeight: newHeight
      (<primitive 219 31 private iconName newHeight> ~= true)
         ifTrue: ['Method setWindowHeight: ', newHeight, ' failed!' print]
|
   setWindowTopEdge: newTopEdge
      (<primitive 219 32 private iconName newTopEdge> ~= true)
         ifTrue: ['Method setWindowTopEdge: ', newTopEdge, ' failed!' print]
|
   setWindowLeftEdge: newLeftEdge
      (<primitive 219 33 private iconName newLeftEdge> ~= true)
         ifTrue: ['Method setWindowLeftEdge: ', newLeftEdge, ' failed!' print]
|
   readInAsciiImage: fileName
      (<primitive 219 34 private iconName fileName> ~= true)
         ifTrue: ['Method readInAsciiImage: ', fileName, ' failed!' print]
|
   writeAsciiImage: fileName
      (<primitive 219 35 private fileName> ~= true)
         ifTrue: ['Method writeAsciiImage: ', fileName, ' failed!' print]
|
   closeIcon ! chk !
      chk <- <primitive 219 0 private iconName>.

      (chk ~= nil)
        ifTrue: ['Icon Object was NOT written out!' print]
|
   openIcon: iconFileName
      iconName <- iconFileName.

      private  <- <primitive 219 1 iconFileName>.

      ^ self
|
   new: iconFileName
      ^ (self openIcon: iconFileName) 
]
