"----------------------------------------------------"
" Painter Class implements simple graphics primitives"
"----------------------------------------------------"

Class Painter :Glyph ! ownerWindow fPen bPen oPen drawMode linePattern x y !
[
   setAPen: pen
      <primitive 200 0 ownerWindow pen>.
      
      fPen <- pen
|
   setBPen: pen
      <primitive 200 1 ownerWindow pen>.
      
      bPen <- pen
|
   setOPen: pen
      <primitive 200 2 ownerWindow pen>.
      
      oPen <- pen
|
   setDrawMode: mode
      <primitive 200 3 ownerWindow mode>.
      
      drawMode <- mode
|
   setLinePattern: newPatternMask
      <primitive 200 21 ownerWindow newPatternMask>.
      
      linePattern <- newPatternMask
|
   getPens
      ^ fPen @ bPen
|
   getOPen
      ^ oPen
|
   getDrawMode
      ^ drawMode
|
   location
      ^ x @ y
|
   ownerIs
      ^ ownerWindow
|
   movePenTo: newPoint
      <primitive 200 4 ownerWindow (newPoint x) (newPoint y)>.
      
      x <- newPoint x.
      y <- newPoint y
|
   drawTo: aPoint
      <primitive 200 5 ownerWindow (aPoint x) (aPoint y)>.
      
      x <- aPoint x.
      y <- aPoint y
|
   drawLineFrom: fPoint to: tPoint ! xt yt !
      xt <- tPoint x.
      yt <- tPoint y.
      
      <primitive 200 6 ownerWindow (fPoint x) (fPoint y) xt yt>
|
   drawBoxFrom: fPoint to: tPoint
      <primitive 200 7 ownerWindow (fPoint x) (fPoint y) (tPoint x) (tPoint y)>
|
   drawCircle: cPoint radius: r
      <primitive 200 8 ownerWindow (cPoint x) (cPoint y) r>
|
   drawEllipse: cPoint minaxis: a maxaxis: b
      <primitive 200 9 ownerWindow (cPoint x) (cPoint y) a b>
|
   drawPolygon: borderObj         " borderObjects are NOT necessarily Polygons! "
      <primitive 200 10 ownerWindow borderObj>

      "or <primitive 187 6 ownerWindow borderObj>"
|
   drawPixelAt: aPoint
      <primitive 200 11 ownerWindow (aPoint x) (aPoint y)>.
      
      x <- aPoint x.
      y <- aPoint y
|
   drawText: text at: aPoint        " Sorry, no font control for this "
      <primitive 200 19 ownerWindow text (aPoint x ) (aPoint y)>
|
   new: newOwnerWindow
      ownerWindow <- newOwnerWindow.

      ^ self
]

"----------------------------------------------------"
" Image Class implements Image graphics primitives   "
"----------------------------------------------------"

Class Image :Glyph ! private ownerWindow !
[
   ownerIs
      ^ ownerWindow
|
   getStartPoint ! left top !
      left <- <primitive 200 14 ownerWindow 0 private>.
      top  <- <primitive 200 14 ownerWindow 1 private>.
      
      ^ left @ top
|
   getImageSize ! width height !
      width  <- <primitive 200 14 ownerWindow 2 private>.
      height <- <primitive 200 14 ownerWindow 3 private>.
      
      ^ width @ height
|
   setOrigin: aPoint ! x y !
      x <- aPoint x.
      y <- aPoint y.
      
      <primitive 200 15 ownerWindow 0 x private>.
      <primitive 200 15 ownerWindow 1 y private>
|
   setExtent: sizePoint ! w h !
      w <- sizePoint x.
      h <- sizePoint y.
      
      <primitive 200 15 ownerWindow 2 w private>.
      <primitive 200 15 ownerWindow 3 h private>
|
   setImageDepth: d
      <primitive 200 15 ownerWindow 4 d private>
|
   drawImageAt: aPoint
      <primitive 200 16 ownerWindow (aPoint x) (aPoint y) private>
|
   setImageDataFrom: imageFile
      <primitive 200 17 ownerWindow imageFile private>
|
   saveImageIn: imageFile
      " true indicates that the Image was saved: "
      ^ <primitive 200 18 ownerWindow imageFile private>
|
   getImageDepth
      ^ <primitive 200 14 ownerWindow 4 private>
|
   getImagePlanePick
      ^ <primitive 200 14 ownerWindow 6 private>
|
   getImagePlaneOnOff
      ^ <primitive 200 14 ownerWindow 7 private>
|
   getNextImage
      ^ <primitive 200 14 ownerWindow 8 private>
|
   setImagePlanePick: pp
      <primitive 200 15 ownerWindow 6 pp private>
|
   setImagePlaneOnOff: po
      <primitive 200 15 ownerWindow 7 po private>
|
   setNextImage: newNextImage
      <primitive 200 15 ownerWindow 8 newNextImage private>
|
   grabImageFrom: windowObj startPoint: s endPoint: e ! x y w h !
      x <- s x.
      y <- s y.
      w <- e x.
      h <- e y.
      
      ^ <primitive 200 20 windowObj x y w h private>      
|
   getImageObject
      ^ private
|
   registerTo: newWindowObject
      ownerWindow <- newWindowObject
|
   addImage: width height: h depth: d
      private <- <primitive 200 13 ownerWindow width h d>.

      ^ self
|
   disposeImage
      <primitive 200 12 private>.
      
      ^ nil
]
