//
//               CITScreen include
//
//							  StormC
//
//                version 2002.02.26
//

#ifndef CIT_CITSCREEN_H
#define CIT_CITSCREEN_H TRUE

#include "CITApp.h"

#include <graphics/text.h>
#include <intuition/screens.h>

#define DEF_MONITOR    ~0x00000000    // INVALID_D forces WB-type
#define PAL_HIRES       0x00029000
#define PAL_HIRESLACE   0x00029004
#define NTSC_HIRES      0x00019000
#define NTSC_HIRESLACE  0x00019004

class CITScreenClass;

class CITScreen:public CITAppClass
{
  public:
    TTextAttr defTextAttr;
    TextFont* defTextFont;
    Screen*   screen;

    CITScreen();
    CITScreen(char *Name);
    ~CITScreen();

    void InsObject(CITScreenClass &Object,BOOL &Err);
    void RemObject(CITScreenClass &Object);
    void Depth(UWORD d);
    void Display(ULONG ID);
    void ScreenFont(char *name, short Height, short Width = 0);
    void DefaultFont(char *name, short Height, short Width = 0);
    void Caption(char *title);
    void Public(char *Name);
    void Use(Screen *sc);
    void AutoScroll();
    void Interleaved();
    void ToFront();
    void ToBack();

    UWORD Depth();
    
  protected:
    friend class CITApp;

    struct DrawInfo* drawinfo;

    virtual BOOL Create(class CITApp* CITApp);
    virtual void Delete();
    virtual void HandleEvent(ULONG Sigs);

  private:
    CITList   objectList;
    Screen*   useScr;
    ULONG     displayMode;
    TTextAttr scrTextAttr;
    TextFont* scrTextFont;
    char*     screenName;
    char*     defaultTitle;
    UWORD     Pens_3D;
    UWORD     depth;
    UWORD     flags;

    void delScr();
    void SetUp(UWORD Depth);
};

class CITWorkbench:public CITScreen
{
  public:
    CITWorkbench() { Public("Workbench");}
};

class CITScreenClass:public CITNode
{
  public:
    CITScreen* CITScr;
    
    CITScreenClass();
    ~CITScreenClass();

    DrawInfo* drawinfo;

  protected:
    friend class CITScreen;
    
    virtual BOOL Create(class CITScreen* scr);
    virtual void Delete(); 
    virtual void HandleEvent(ULONG Sigs);

    ULONG  eventSigMask;
};

#endif
