/*
   FileTypes module
   EvenMore FileIO plugin
   Author: Chris Perver
   Copyright (c) 2001
*/


OPT REG=5

LIBRARY 'filetypes.plugin',1,1,'FileTypes 1.02' IS em_main, em_end, em_info, em_pluginid, em_begin, em_format

MODULE 'tools/ctype', '*epo'
MODULE 'sven/patternstringf',
       'sven/patternargs',
       'sven/runback'

CONST MAXBUFF = 255
ENUM NOFILE,
     ISFILE,
     ISPATH

CONST MAXLINELEN=1000



PROC openfiletypelist(emp:PTR TO em_pluginobj)
  DEF namestr_copy[MAXBUFF]:STRING, foundtype = FALSE, equalspos, typestr[MAXBUFF]:STRING, progstr
  DEF fh = 0, buf[MAXLINELEN]:ARRAY, n=0
  DEF s, first = NIL, last = NIL

  IF fh := Open('PROGDIR:filetypes.txt',OLDFILE)
    WHILE Fgets(fh,buf,MAXLINELEN)
      IF (s := String(StrLen(buf))) = NIL THEN RETURN
      StrCopy(s,buf,ALL)
      IF last THEN Link(last,s) ELSE first:=s
      last:=s
      INC n
    ENDWHILE
    Close(fh)

    StrCopy(namestr_copy, FilePart(emp.filename))

    s:=first
    WHILE s

      IF (equalspos := InStr(s, '=')) >= 0
        StrCopy(typestr, s, equalspos)
        ParsePatternNoCase(typestr, typestr, (equalspos * 2) + 2)
        IF MatchPatternNoCase(typestr, namestr_copy)
          progstr := TrimStr(s + equalspos + 1)
          execprog(progstr, emp.filename)
          foundtype := TRUE
        ENDIF
      ENDIF

      EXIT foundtype

      s:=Next(s)
    ENDWHILE
    DisposeLink(first)
  ENDIF
ENDPROC foundtype


->> execprog(prog:PTR TO CHAR, exeargs = NIL:PTR TO LONG)
PROC execprog(prog:PTR TO CHAR, file = NIL:PTR TO CHAR, data = NIL) HANDLE
  DEF pd = NIL:PTR TO pattern_data, executestr[MAXBUFF]:STRING

  StrCopy(executestr, prog)

  pd := createPatternData(executestr, "%",
                          [PARGS_Type_String,  's', 0,
                           PARGS_Type_Decimal, 'l', 0,
                           PARGS_Type_END]:pattern_arg)

  runback(patternStringF(executestr, pd, [file, data]))
EXCEPT DO
  freePatternData(pd)
ENDPROC

-> *** STANDARD PROCS FOR PLUGINS


PROC em_main(emp:PTR TO em_pluginobj)
  DEF result
  result := openfiletypelist(emp)
ENDPROC result

PROC em_end()      IS EMPTY

PROC em_info()     IS 'FileTypes 1.02'

PROC em_format()   IS EMPTY

PROC em_pluginid() IS "FTYP"

PROC em_begin()    IS EMPTY

PROC main()        IS EMPTY
