/*
   ProWrite2Text
   EvenMore FileIO plugin
   Author: Chris Perver
   Copyright (c) 2001
*/


OPT REG=5

LIBRARY 'prowrite2text.plugin',1,1,'ProWrite2Text 1.02' IS em_main, em_end, em_info, em_pluginid, em_begin, em_format

MODULE 'tools/ctype', '*epo'

DEF mem2, len2


PROC em_isdatatype(memadr, lenadr)
   DEF vers = FALSE
   DEF w:PTR TO LONG

   -> Check for FORM header

   w := Long(memadr)
   IF w = "FORM"
     w := Long(memadr + 8)
     IF w = "WORD" THEN vers := TRUE
   ENDIF
ENDPROC vers


PROC em_parsedata(memadr, lenadr)
  DEF count = 0, count2 = 0
  DEF wrapping = 80, notdonewrapping = TRUE, currchar = 0
  DEF notdone = TRUE
  -> Allocate memory for file
->  IF (mem2 := New(lenadr + 1)) = NIL THEN RETURN -1
->  mem2[lenadr + 1] := "\n"                                                      -> Put safety LF at the end of mem
  DEF w:PTR TO LONG
  DEF ispara = FALSE, istabs = FALSE

  mem2 := memadr

   WHILE notdone AND (count < lenadr)

     w := Long(memadr + count)

         SELECT w
           -> ???
           CASE "PARA"
             count := count + 4
             mem2[count2++] := "\n"
          ->   currchar := 0
             ispara := TRUE
           CASE "TABS"
             count := count + 4
             istabs := TRUE
           CASE "FSCC"
             count := count + 4
           CASE "HEAD"
             count := count + 4
           CASE "FOOT"
             count := count + 4
           CASE "RMST"
             count := count + 4
           CASE "LMST"
             count := count + 4
           CASE "PCTS"
             count := count + 4
           CASE "BMAP"
             count := count + 4
           CASE "TEXT"
         ->    count := count + 7
             IF memadr[count + 7] <> $00
               count := count + 8

                 IF istabs THEN mem2[count2++] := "\t"

                 istabs := FALSE

                 WHILE (memadr[count] <> $00)
                   mem2[count2++] := memadr[count++]
                   INC currchar
                   IF currchar >= wrapping
                     notdonewrapping := TRUE
                     WHILE notdonewrapping
                       SELECT 256 OF memadr[count]
                         DEFAULT
                           IF isspace(memadr[count]) = FALSE
                             DEC count
                             DEC count2
                           ELSE
                             notdonewrapping := FALSE
                           ENDIF
                       ENDSELECT
                     ENDWHILE
                     INC count

                     currchar := 0
                     memadr[count2++] := "\n"
                     IF istabs THEN mem2[count2++] := "\t"
                   ENDIF
                 ENDWHILE

                 -> STRIP TRAILING COMMANDS

                 w := Long(memadr + count - 4)
                 SELECT w
                   CASE "TEXT"
                    count2 := count2 - 4
                    count := count - 4
           ->         mem2[count2++] := "\n"
           ->         currchar := 0
                   CASE "PARA"
                    count2 := count2 - 4
                    count := count - 4
             ->       mem2[count2++] := "\n"
             ->       currchar := 0
             ->       ispara := FALSE
                 ->   istabs := FALSE
                   CASE "TABS"
                    count2 := count2 - 4
                    count := count - 4
           ->         istabs := FALSE
                   CASE "FSCC"
                    count2 := count2 - 4
                   CASE "HEAD"
                    count2 := count2 - 4
                   CASE "FOOT"
                    count2 := count2 - 4
                   CASE "PTCS"
                     count2 := count2 - 4
                   CASE "BMAP"
                     count2 := count2 - 4
                 ENDSELECT
              ->   INC count

                 mem2[count2++] := "\n"
                 currchar := 0
             ELSE
               mem2[count2++] := "\n"
               currchar := 0
               INC count
             ENDIF
           DEFAULT
             INC count
         ENDSELECT

->       DEFAULT

->         INC count
->     ENDSELECT

   ENDWHILE


  mem2[count2] := "\n"

 -> IF memadr
 ->   Dispose(memadr); memadr := NIL
 -> ENDIF
ENDPROC mem2, count2
-><

-> *** STANDARD PROCS FOR PLUGINS


PROC em_main(epo:PTR TO em_pluginobj)
  mem2, len2 := em_parsedata(epo.buffer, epo.length)
  epo.buffer := mem2
  epo.length := len2
  RETURN TRUE
ENDPROC

PROC em_begin(epo:PTR TO em_pluginobj)
  DEF vers
  vers := em_isdatatype(epo.buffer, epo.length)
  IF vers
    RETURN TRUE
  ELSE
    RETURN FALSE
  ENDIF

ENDPROC

PROC em_end()      IS EMPTY

PROC em_info()     IS 'ProWrite2Text 1.02'

PROC em_pluginid() IS "FILE"

PROC em_format()   IS 'ProWrite'

PROC main()        IS EMPTY
