/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_arexx.c
 */

BOOL IsReal(char * );

BOOL IsHex(char * , long * );

BOOL IsDec(char * , long * );

long __asm printlist_rxfunc(register __a1 ULONG * );

long __asm findtask_rxfunc(register __a1 ULONG * );

long __asm removetask_rxfunc(register __a1 ULONG * );

long __asm freezetask_rxfunc(register __a1 ULONG * );

long __asm activatetask_rxfunc(register __a1 ULONG * );

long __asm signaltask_rxfunc(register __a1 ULONG * );

long __asm breaktask_rxfunc(register __a1 ULONG * );

long __asm settaskpri_rxfunc(register __a1 ULONG * );

long __asm removeport_rxfunc(register __a1 ULONG * );

long __asm getlocknumber_rxfunc(register __a1 ULONG * );

long __asm removelocks_rxfunc(register __a1 ULONG * );

long __asm removelock_rxfunc(register __a1 ULONG * );

long __asm getpriority_rxfunc(register __a1 ULONG * );

long __asm setpriority_rxfunc(register __a1 ULONG * );

long __asm findnode_rxfunc(register __a1 ULONG * );

long __asm closelib_rxfunc(register __a1 ULONG * );

long __asm removelib_rxfunc(register __a1 ULONG * );

long __asm removedev_rxfunc(register __a1 ULONG * );

long __asm removeres_rxfunc(register __a1 ULONG * );

long __asm obtainsem_rxfunc(register __a1 ULONG * );

long __asm releasesem_rxfunc(register __a1 ULONG * );

long __asm removesem_rxfunc(register __a1 ULONG * );

long __asm removeinput_rxfunc(register __a1 ULONG * );

long __asm findresident_rxfunc(register __a1 ULONG * );

long __asm findinterrupt_rxfunc(register __a1 ULONG * );

long __asm removeinterrupt_rxfunc(register __a1 ULONG * );

long __asm flushdevs_rxfunc(register __a1 ULONG * );

long __asm flushfonts_rxfunc(register __a1 ULONG * );

long __asm flushlibs_rxfunc(register __a1 ULONG * );

long __asm flushall_rxfunc(register __a1 ULONG * );

long __asm clearreset_rxfunc(register __a1 ULONG * );

long __asm poptofront_rxfunc(register __a1 ULONG * );

long __asm closewindow_rxfunc(register __a1 ULONG * );

long __asm closescreen_rxfunc(register __a1 ULONG * );

long __asm closefont_rxfunc(register __a1 ULONG * );

long __asm removefont_rxfunc(register __a1 ULONG * );

long __asm removecommand_rxfunc(register __a1 ULONG * );

long __asm removeassign_rxfunc(register __a1 ULONG * );

long __asm removeassignlist_rxfunc(register __a1 ULONG * );

extern char * WindowTexte[26];

extern BYTE WindowIDs[25];

long __asm openwindow_rxfunc(register __a1 ULONG * );

extern struct MUI_Command arexx_list[52];

char * FindMyARexxPort(char * );

ULONG SafePutToPort(struct Message * , STRPTR );

short SendStartupMsg(char * , char * , BOOL );

struct Task * MyFindTask(char * );

BOOL MyRemoveTask(char *, BOOL );

BOOL MyFreezeTask(char * );

BOOL MyActivateTask(char * );

BOOL MySignalTask(char * , char * );

struct List * MyGetList(char * );

struct Node * MyFindName(char * , char * );

struct Screen * MyFindScreen(char * );

struct Window * MyFindWindow(char * );

