/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_assigns.c
 */

struct   AssEntry {
   struct AssEntry *ass_next;
   char  *ass_adr;
   char  ass_address[ADDRESSLENGTH];
   char  ass_name[FILENAMELENGTH+2];
   char  *ass_path;
   char  *ass_realpath;
   ULONG ass_type;
};

extern int asscnt;

LONG __asm asslist_dspfunc(register __a2 char ** , register __a1 struct AssEntry * , register __a0 struct Hook * );

extern struct Hook asslist_dsphook;

LONG __asm asslist_cmpnamefunc(register __a1 struct AssEntry * , register __a2 struct AssEntry * );

extern struct Hook asslist_cmpnamehook;

LONG __asm asslist_cmppathfunc(register __a1 struct AssEntry * , register __a2 struct AssEntry * );

extern struct Hook asslist_cmppathhook;

void FreeAssigns(void);

int GetAssigns(struct AssEntry ** );

void PrintAssigns(char * );

void ShowAssigns(void);

void SendAssList(void);

extern APTR WI_Assigns;

extern APTR asslist;

extern APTR asstext;

extern APTR asscount;

extern APTR CY_AssSort;

extern int asssortstate;

extern APTR BT_AssUpdate;

extern APTR BT_AssPrint;

extern APTR BT_AssRemove;

extern APTR BT_AssExit;

extern APTR AssSortList[5];

void AssignsWindow(BOOL );

