/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_classes.c
 */

struct   ClassEntry {
   struct ClassEntry  *cse_next;
   struct IClass *cse_adr;
   char cse_address[ADDRESSLENGTH];
   char cse_super[80];
   char cse_dispatch[ADDRESSLENGTH];
   char cse_classname[80];
   char cse_objcnt[10+2];
   char cse_subcnt[10+2];
};

extern int classcnt;

LONG __asm classlist_cmpaddressfunc(register __a1 struct ClassEntry * , register __a2 struct ClassEntry * );

extern struct Hook classlist_cmpaddresshook;

LONG __asm classlist_cmpnamefunc(register __a1 struct ClassEntry * , register __a2 struct ClassEntry * );

extern struct Hook classlist_cmpnamehook;

LONG __asm classlist_cmpsuperfunc(register __a1 struct ClassEntry * , register __a2 struct ClassEntry * );

extern struct Hook classlist_cmpsuperhook;

LONG __asm classlist_dspfunc(register __a2 char ** , register __a1 struct ClassEntry * , register __a0 struct Hook * );

extern struct Hook classlist_dsphook;

void FFreeClass(void);

void UpdateClass(void);

int GetClass(struct ClassEntry ** );

void PrintClass(char * );

void ShowClass(void);

void SendClassList(void);

void GetClassMore(struct IClass * );

extern APTR ClassSortList[4];

extern APTR WI_Class;

extern APTR classlist;

extern APTR classtext;

extern APTR classcount;

extern APTR CY_ClassSort;

extern int classsortstate;

extern APTR BT_ClassUpdate;

extern APTR BT_ClassPrint;

extern APTR BT_ClassRemove;

extern APTR BT_ClassMore;

extern APTR BT_ClassExit;

void ClassWindow(BOOL );

