/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_commands.c
 */

struct   CommandEntry {
   struct CommandEntry *cm_next;
   char  *cm_adr;
   char  cm_address[ADDRESSLENGTH];
   char  cm_name[FILENAMELENGTH+2];
   char  cm_uc[10];
   char  cm_lower[10];
   char  cm_upper[10];
   char  cm_size[10];
};

extern int comcnt;

LONG __asm comlist_dspfunc(register __a2 char ** , register __a1 struct CommandEntry * , register __a0 struct Hook * );

extern struct Hook comlist_dsphook;

void FreeCommands(void);

int GetCommands(struct CommandEntry ** );

void PrintCommands(char * );

void ShowCommands(void);

void SendComList(void);

extern APTR WI_Commands;

extern APTR comlist;

extern APTR comtext;

extern APTR comcount;

extern APTR CY_ComSort;

extern int comsortstate;

extern APTR BT_ComUpdate;

extern APTR BT_ComPrint;

extern APTR BT_ComRemove;

extern APTR BT_ComExit;

extern APTR ComSortList[4];

void CommandsWindow(BOOL );

