/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_commodity.c
 */

struct   CxEntry {
   struct CxEntry  *cxe_next;
   char *cxe_adr;
   char cxe_address[ADDRESSLENGTH];
   char cxe_type[NODETYPELEN];
   char cxe_pri[PRIORITYLENGTH];
   char cxe_name[CBD_NAMELEN];
   char cxe_title[CBD_TITLELEN];
   char cxe_descr[CBD_DESCRLEN];
   char cxe_task[10+2];
   char cxe_port[10+2];
   char cxe_unique[10+2];
   UBYTE cxe_flags_int;
   char cxe_flags[10+2];
};

struct  CxSubEntry {
   char cse_address[ADDRESSLENGTH];
   char cse_type[NODETYPELEN];
   char cse_pri[PRIORITYLENGTH];
};

extern int cxcnt;

LONG __asm cxlist_cmpprifunc(register __a1 struct CxEntry * , register __a2 struct CxEntry * );

extern struct Hook cxlist_cmpprihook;

LONG __asm cxlist_cmpaddressfunc(register __a1 struct CxEntry * , register __a2 struct CxEntry * );

extern struct Hook cxlist_cmpaddresshook;

LONG __asm cxlist_cmpnamefunc(register __a1 struct CxEntry * , register __a2 struct CxEntry * );

extern struct Hook cxlist_cmpnamehook;

LONG __asm cxlist_dspfunc(register __a2 char ** , register __a1 struct CxEntry * , register __a0 struct Hook * );

extern struct Hook cxlist_dsphook;

void FreeCx(void);

void GetCxEntry(struct CxEntry * , struct MyCxObj * );

void UpdateCx(void);

int GetCx(struct CxEntry ** );

void PrintCx(char * );

void ShowCx(void);

void SendCxList(void);

void GetCxMore(struct MyCxObj * );

extern APTR CxSortList[4];

extern APTR WI_Cx;

extern APTR cxlist;

extern APTR cxtext;

extern APTR cxcount;

extern APTR CY_CxSort;

extern int cxsortstate;

extern APTR BT_CxAppear;

extern APTR BT_CxDisappear;

extern APTR BT_CxEnable;

extern APTR BT_CxDisable;

extern APTR BT_CxKill;

extern APTR BT_CxListChg;

extern APTR BT_CxUnique;

extern APTR BT_CxUpdate;

extern APTR BT_CxPrint;

extern APTR BT_CxPriority;

extern APTR BT_CxRemove;

extern APTR BT_CxMore;

extern APTR BT_CxExit;

void CxWindow(BOOL );

