/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_expansions.c
 */

struct   ExpEntry {
   struct ExpEntry *exp_next;
   struct ConfigDev *exp_adr;
   char  exp_address[ADDRESSLENGTH];
   char  exp_flags[6];
   char  exp_boardaddr[10];
   char  exp_boardsize[10];
   char  exp_type[6];
   char  exp_product[6];
   char  exp_manufacturer[10];
   char  exp_serialnumber[12];
   char  exp_manufname[50];
   char  exp_prodname[50];
   char  exp_prodclass[50];
   char  exp_complete_product[128];
};

extern APTR BT_ExpPrint;

extern APTR BT_ExpMore;

extern APTR BT_ExpExit;

extern APTR exptext;

extern APTR explist;

LONG __asm explist_dspfunc(register __a2 char ** , register __a1 struct ExpEntry * , register __a0 struct Hook * );

extern struct Hook explist_dsphook;

void FreeExpansions(void);

int GetExpansions(struct ExpEntry ** );

void PrintExpansions(char * );

unsigned char * GetProcessorsText(UWORD );

UBYTE * GetCustomChipsText(UBYTE );

void ShowExpansions(void);

void SendExpList(void);

void GetExpansionMore(struct ConfigDev * );

void ExpansionsWindow(BOOL );

