/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_extras.c
 */

struct   ListEntry {
   ULONG le_next;
   ULONG le_adr;
   char  le_address[ADDRESSLENGTH];
   char  le_name[NODENAMELENGTH+2];
   char  le_pri[PRIORITYLENGTH];
};

struct   FlagEntry {
   char  *fe_name;
   char  *fe_text;
};

struct WinFlag {
   char  *wf_title2;
   char  *wf_fieldname;
   ULONG wf_flags;
   struct LongFlag *wf_longflag;
   struct MaskedLongFlag *wf_mlongflag;
   char  wf_fieldtype;
};

#define WINDOWTITLELEN  80

#define SPACE40 "                                        "

extern UBYTE updatetimetext[9];

extern ULONG updatetimestate;

ULONG MakeListID(char , char , char , char );

ULONG MakeDetailID(char , char , char , char );

struct Node * HandleNodeDetails(APTR , char * );

void __stdargs MySetContents(APTR , char * , ...);

void __stdargs MySetContentsHealed(APTR , char * , ...);

void MyFreePoolStructs( APTR *, APTR, APTR, APTR );

void SetCountText(APTR , int );

void SetCloseRequest(APTR , int );

extern struct WinFree * SingleDetailWinFree;

char * MyGetWindowTitle(char * , char * );

void HandleFlagsButtonPressed(APTR , struct WinFree * , char * , char * , ULONG , struct LongFlag * , struct MaskedLongFlag * , char );

void HandleWindowOpen(struct WinFree * , char * , char * );

void HandleWindowClose(struct WinFree * );

extern ULONG LastListID;

void SetWindowOpen(APTR , APTR , ULONG );

void SetWindowClose(APTR , BOOL );

void ApplicationSleep(void);

void AwakeApplication(void);

void RedrawActiveEntry(APTR );

void RemoveActiveEntry(APTR );

void InsertBottomEntry(APTR , APTR * );

void InsertSortedEntry(APTR , APTR * );

struct ListEntry * GetActiveEntry(APTR );

void SetListActive(APTR , int );

void SetListviewDoubleClick(APTR , int );

APTR KeyButtonA(char * , int );

APTR KeyButtonB(char * , char , int );

APTR KeyButtonF(char , ULONG );

LONG __asm flaglist_dspfunc(register __a2 char ** , register __a1 struct FlagEntry * , register __a0 struct Hook * );

extern struct Hook flaglist_dsphook;

void GetFlagsMore(char * , char * , ULONG , struct LongFlag * , struct MaskedLongFlag * , char );

APTR MyListviewObject(unsigned char * , APTR );

APTR MySortedListviewObject(unsigned char * , APTR, APTR );

APTR MyBelowSortedListview(APTR * , APTR * , APTR * , char const ** , int );

APTR MyBelowListview(APTR * , APTR * );

APTR MyLabel(char * );

APTR MyLabel2(char * );

APTR MyHSpace(int );

APTR MyVSpace(int );

APTR MyTextObject(void);

APTR MyTextObject2(void);

APTR MyTextObject3(char * );

APTR MyTextObject4(char * );

APTR MyTextObject5(char * );

APTR MyTextObject6(char *, struct TextFont * );

LONG __asm list_cmpaddressfunc(register __a1 struct ListEntry * , register __a2 struct ListEntry * );

extern struct Hook list_cmpaddresshook;

LONG __asm list_cmpnormalfunc(register __a1 struct ListEntry * , register __a2 struct ListEntry * );

extern struct Hook list_cmpnormalhook;

LONG __asm list_cmpnamefunc(register __a1 struct ListEntry * , register __a2 struct ListEntry * );

extern struct Hook list_cmpnamehook;

extern char main_title[80];

APTR GetApplication(void);

void __asm cpuinterval_callfunc(register __a1 unsigned char ** );

extern struct Hook cpuinterval_callhook;

ULONG __asm hexstring_editfunc(register __a0 struct Hook * , register __a2 struct SGWork * , register __a1 ULONG * );

extern struct Hook hexstring_edithook;

ULONG __asm realstring_editfunc(register __a0 struct Hook * , register __a2 struct SGWork * , register __a1 ULONG * );

extern struct Hook realstring_edithook;

void AboutWindow(BOOL );

