/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_fonts.c
 */

struct   FontEntry {
   struct   FontEntry   *font_next;
   struct   TextFont    *font_adr;
   char  font_address[ADDRESSLENGTH];
   char  font_name[FILENAMELENGTH+2];
   char  font_xsize[6];
   char  font_ysize[6];
   char  font_style[6];
   char  font_flags[6];
   char  font_count[8];
   char  font_lochar[6];
   char  font_hichar[6];
   char  font_place[10];
};

extern APTR BT_FontUpdate;

extern APTR BT_FontPrint;

extern APTR BT_FontClose;

extern APTR BT_FontRemove;

extern APTR BT_FontExit;

extern APTR fonttext;

extern APTR fontlist;

extern APTR LB_FontExample;

extern APTR fontcount;

extern int fontcnt;

LONG __asm fontlist_dspfunc(register __a2 char ** , register __a1 struct FontEntry * , register __a0 struct Hook * );

extern struct Hook fontlist_dsphook, fontlist_cmphook;

void FreeFonts(void);

void FlushFonts(void);

int GetFonts(struct FontEntry ** );

void PrintFonts(char * );

void ShowFonts(void);

void SendFontList(void);

void FontsWindow(BOOL );

