/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_libs.c
 */

struct   LibEntry {
   struct LibEntry *lib_next;
   char  *lib_ptr;
   char  lib_address[ADDRESSLENGTH];
   char  lib_name[FILENAMELENGTH+2];
   char  lib_pri[PRIORITYLENGTH];
   char  lib_ver[VERSIONLENGTH];
   char  lib_ocnt[8];
   char  lib_rcnt[6];
   char  lib_type[NODETYPELEN];
};

extern int libcnt;

extern int devcnt;

extern int rescnt;

LONG __asm liblist_dspfunc(register __a2 char ** , register __a1 struct LibEntry * , register __a0 struct Hook * );

extern struct Hook liblist_dsphook;

int TestResource(struct Library * );

void GetLDRFctList(struct Library *, char);

void GetLDRMore(struct Library * , char * , char * );

void GetLibMore(struct Library * );

void GetDevMore(struct Library * );

void GetResMore(struct Library * );

void PrintLDR(APTR , char , char * );

void PrintLibraries(char * );

void PrintDevices(char * );

void PrintResources(char * );

int FillLDRList(char , struct LibEntry ** );

void FreeLibraries(void);

void FlushLibraries(void);

void FreeDevices(void);

void FlushDevices(void);

void FreeResources(void);

void ShowLibraries(void);

void ShowDevices(void);

void ShowResources(void);

void SendLibList(void);

void SendDevList(void);

void SendResList(void);

extern APTR LibSortList[4];

extern APTR WI_Libraries;

extern APTR liblist;

extern APTR libtext;

extern APTR libcount;

extern APTR CY_LibSort;

extern int libsortstate;

extern APTR BT_LibUpdate;

extern APTR BT_LibPrint;

extern APTR BT_LibPriority;

extern APTR BT_LibClose;

extern APTR BT_LibRemove;

extern APTR BT_LibFunctions;

extern APTR BT_LibMore;

extern APTR BT_LibExit;

void LibrariesWindow(BOOL );

extern APTR WI_Devices;

extern APTR devlist;

extern APTR devtext;

extern APTR devcount;

extern APTR CY_DevSort;

extern int devsortstate;

extern APTR BT_DevUpdate;

extern APTR BT_DevPrint;

extern APTR BT_DevPriority;

extern APTR BT_DevRemove;

extern APTR BT_DevFunctions;

extern APTR BT_DevMore;

extern APTR BT_DevExit;

void DevicesWindow(BOOL );

extern APTR WI_Resources;

extern APTR reslist;

extern APTR restext;

extern APTR rescount;

extern APTR CY_ResSort;

extern int ressortstate;

extern APTR BT_ResUpdate;

extern APTR BT_ResPrint;

extern APTR BT_ResPriority;

extern APTR BT_ResRemove;

extern APTR BT_ResFunctions;

extern APTR BT_ResMore;

extern APTR BT_ResExit;

void ResourcesWindow(BOOL );

