/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_locks.c
 */

struct   LockEntry {
   struct   LockEntry   *lock_next;
   char  *lock_ptr;
   char  lock_address[ADDRESSLENGTH];
   char  lock_access[32];
   char  *lock_path;
};

extern int lockanzahl;

extern int hiddenanzahl;

LONG __asm locklist_cmppathfunc(register __a1 struct LockEntry * , register __a2 struct LockEntry * );

extern struct Hook locklist_cmppathhook;

LONG __asm locklist_dspfunc(register __a2 char ** , register __a1 struct LockEntry * , register __a0 struct Hook * );

extern struct Hook locklist_dsphook;

void FreeLocks(void);

APTR GetLocks(int , char * , struct LockEntry ** );

void PrintLocks(char * );

void ShowLocks(void);

void SendLockList(void);

extern APTR WI_Locks;

extern APTR locklist;

extern APTR locktext;

extern APTR lockcount;

extern APTR CY_LockSort;

extern int locksortstate;

extern APTR lockpattern;

extern APTR locktext2;

extern APTR BT_LockUpdate;

extern APTR BT_LockPrint;

extern APTR BT_LockRemove;

extern APTR BT_LockExit;

extern APTR LockSortList[4];

void LocksWindow(BOOL );

