/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_lowmemory.c
 */

struct   LowMemoryEntry {
   struct LowMemoryEntry *lowmemory_next;
   struct Interrupt  *lowmemory_adr;
   char  lowmemory_address[10];
   char  lowmemory_name[NODENAMELENGTH+2];
   char  lowmemory_type[NODETYPELEN+1];
   char  lowmemory_pri[10];
   char  lowmemory_data[10];
   char  lowmemory_code[20];
};

void FreeLowMemory (void);

int GetLowMemory (struct LowMemoryEntry **first);

void PrintLowMemory (char *filename);

void ShowLowMemory (void);

void SendLowMemory (void);

void LowMemoryWindow(BOOL );

