/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_memory.c
 */

struct   MemoEntry {
   struct   MemoEntry   *mem_next;
   struct   MemHeader   *mem_adr;
   char  mem_address[10];
   char  mem_name[NODENAMELENGTH+2];
   char  mem_type[NODETYPELEN+1];
   char  mem_pri[10];
   char  mem_lower[10];
   char  mem_upper[10];
   char  mem_attributes[10];
};

void FreeMemory (void);

int GetMemory (struct MemoEntry **first);

void PrintMemory (char *filename);

void ShowMemory (void);

void SendMemList (void);

void MemoryWindow(BOOL );

void GetChunkList(struct MemHeader *);


