/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_mount.c
 */

struct   MountEntry {
   struct   MountEntry  *mt_next;
   struct   DeviceNode  *mt_adr;
   char  mt_address[ADDRESSLENGTH];
   char  mt_name[FILENAMELENGTH+2];
   char  mt_unit[10];
   char  mt_heads[10];
   char  mt_cyl[10];
   char  mt_diskstate[12];
   char  mt_filesystem[10];
   char  mt_handler[FILENAMELENGTH+2];
};

extern APTR BT_MountUpdate;

extern APTR BT_MountPrint;

extern APTR BT_MountMore;

extern APTR BT_MountExit;

extern APTR mounttext;

extern APTR mountlist;

extern APTR MountAdd1;

extern APTR MountAdd2;

extern APTR MountText0;

extern APTR MountText1;

extern APTR MountText2;

extern APTR MountText3;

extern APTR MountText4;

extern APTR MountText5;

extern APTR MountGroup1;

extern APTR MountGroup2;

extern APTR MountGroup3;

extern APTR MountGroup4;

extern APTR MountGroup5;

extern APTR MountGroup6;

extern APTR MountGroup7;

extern APTR MountGroup8;

extern APTR MountGroup9;

extern APTR MountGroup10;

extern APTR mountcount;

extern int mountcnt;

extern APTR oldwindowptr;

void NoReqOn(void);

void NoReqOff(void);

LONG __asm mountlist_dspfunc(register __a2 char ** , register __a1 struct MountEntry * , register __a0 struct Hook * );

extern struct Hook mountlist_dsphook, mountlist_cmphook;

char * GetDiskState(long * );

char * GetDiskType(long * );

void FreeMounts(void);

int GetMounts(struct MountEntry ** );

void PrintMounts(char * );

void ShowMounts(void);

void SendMountList(void);

void GetMountMore(struct DeviceNode * );

void MountWindow (BOOL state);
