/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_ports.c
 */

struct   PortEntry {
   struct   PortEntry   *pt_next;
   struct   MsgPort     *pt_adr;
   char  pt_address[ADDRESSLENGTH];
   char  pt_name[NODENAMELENGTH+2];
   char  pt_pri[PRIORITYLENGTH];
   char  pt_sigbit[10];
   char  pt_sigtask[NODENAMELENGTH+2];
   char  pt_flags[16];
};

extern int portcnt;

LONG __asm portlist_dspfunc(register __a2 char ** , register __a1 struct PortEntry * , register __a0 struct Hook * );

extern struct Hook portlist_dsphook;

void FreePorts(void);

int GetPorts(struct PortEntry ** );

void PrintPorts(char * );

void ShowPorts(void);

void SendPortList(void);

void GetPortMore(struct MsgPort * );

extern APTR WI_Ports;

extern APTR portlist;

extern APTR porttext;

extern APTR portcount;

extern APTR CY_PortSort;

extern int portsortstate;

extern APTR BT_PortUpdate;

extern APTR BT_PortPrint;

extern APTR BT_PortRemove;

extern APTR BT_PortPriority;

extern APTR BT_PortMore;

extern APTR BT_PortExit;

extern APTR PortSortList[4];

void PortsWindow(BOOL );

