/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_screenmode.c
 */

struct  SModeEntry{
   struct SModeEntry *sme_next;
   ULONG sme_smodeid;
   char sme_id[ADDRESSLENGTH];
   char sme_name[70];
   char sme_width[10];
   char sme_height[10];
   char sme_depth[10];
};

extern int smodecnt;

extern APTR smodemoretext0;

extern APTR smodemoretext1;

extern APTR smodemoretext2;

extern APTR smodemoretext3;

extern APTR smodemoretext4;

extern APTR smodemoretext5;

LONG __asm smodelist_cmpidfunc(register __a1 struct SModeEntry * , register __a2 struct SModeEntry * );

extern struct Hook smodelist_cmpidhook;

LONG __asm smodelist_cmpresfunc(register __a1 struct SModeEntry * , register __a2 struct SModeEntry * );

extern struct Hook smodelist_cmpreshook;

LONG __asm smodelist_cmpnamefunc(register __a1 struct SModeEntry * , register __a2 struct SModeEntry * );

extern struct Hook smodelist_cmpnamehook;

LONG __asm smodelist_dspfunc(register __a2 char ** , register __a1 struct SModeEntry * , register __a0 struct Hook * );

extern struct Hook smodelist_dsphook;

void FreeSMode(void);

void GetSModeEntry(struct SModeEntry * , ULONG );

void UpdateSMode(void);

int GetSMode(struct SModeEntry ** );

void PrintSMode(char * );

void ShowSMode(void);

void SendSModeList(void);

void GetSModeMore(struct SModeEntry *);

extern APTR SModeSortList[4];

extern APTR WI_SMode;

extern APTR smodelist;

extern APTR smodetext;

extern APTR smodecount;

extern APTR CY_SModeSort;

extern int smodesortstate;

extern APTR BT_SModeUpdate;

extern APTR BT_SModePrint;

extern APTR BT_SModeMore;

extern APTR BT_SModeExit;

void SModeWindow(BOOL );

