/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_semaphores.c
 */

struct   SemEntry {
   struct   SemEntry    *sm_next;
   struct   SignalSemaphore   *sm_adr;
   char  sm_address[ADDRESSLENGTH];
   char  sm_name[FILENAMELENGTH+2];
   char  sm_nestcount[5];
   char  sm_queuecount[5];
   char  sm_owner[NODENAMELENGTH+2];
};

extern APTR BT_SemUpdate;

extern APTR BT_SemPrint;

extern APTR BT_SemObtain;

extern APTR BT_SemRelease;

extern APTR BT_SemRemove;

extern APTR BT_SemExit;

extern APTR semtext;

extern APTR semlist;

extern APTR semcount;

extern int semcnt;

LONG __asm semlist_dspfunc(register __a2 char ** , register __a1 struct SemEntry * , register __a0 struct Hook * );

extern struct Hook semlist_dsphook, semlist_cmphook;

void FreeSemaphores(void);

int GetSemaphores(struct SemEntry ** );

void PrintSemaphores(char * );

void ShowSemaphores(void);

void SendSemList(void);

void SemaphoresWindow(BOOL );

