/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */


/* Prototypes for functions defined in
objects/scout_windows.c
 */

struct   WinEntry {
   struct   WinEntry *wn_next;
   char  *wn_adr;
   char  wn_address[10+2];
   char  wn_position[10+2];
   char  wn_size[10+2];
   char  wn_flags[10+2];
   char  wn_idcmp[10+2];
   char  wn_title[TEXTLENGTH+2+4]; //Ohne diese 4 zustzlichen Bytes gibt
                                   // es einen MungWall-Hit!
   char  wn_type;
};

extern APTR BT_WinUpdate;

extern APTR BT_WinPrint;

extern APTR BT_WinClose;

extern APTR BT_WinToFront;

extern APTR BT_WinMore;

extern APTR BT_WinExit;

extern APTR wintext;

extern APTR winlist;

extern APTR winmoretext0;

extern APTR winmoretext1;

extern APTR winmoretext2;

extern APTR winmoretext3;

extern APTR winmoretext4;

extern APTR winmoretext5;

extern APTR winmoretext6a;

extern APTR winmoretext6b;

extern APTR winmoretext7a;

extern APTR winmoretext7b;

extern APTR winmoretext8;

extern APTR winmoretext9;

extern APTR winmoretext10;

extern APTR winmoretext11;

extern APTR winmoretext12;

extern APTR winmoretext13;

extern APTR winmoretext14;

extern APTR screenmoretext0;

extern APTR screenmoretext1;

extern APTR screenmoretext2;

extern APTR screenmoretext3;

extern APTR screenmoretext4;

extern APTR screenmoretext5;

extern APTR screenmoretext6;

extern APTR screenmoretext7;

extern APTR screenmoretext8;

extern APTR screenmoretext9;

extern APTR screenmoretext10;

void CloseScreenAll(struct Screen * );

LONG __asm winlist_dspfunc(register __a2 char ** , register __a1 struct WinEntry * , register __a0 struct Hook * );

extern struct Hook winlist_dsphook;

void FreeWindows(void);

int GetWindows(struct WinEntry ** );

void PrintWindows(char * );

void ShowWindows(void);

void SendWinList(void);

void GetWindowMore(struct Window * );

void GetScreenMore(struct Screen * );

void WindowsWindow(BOOL );

