/**
 * Scout - The Amiga System Monitor
 *
 *------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You must not use this source code to gain profit of any kind!
 *
 *------------------------------------------------------------------
 *
 * @author Andreas Gelhausen
 * @author Richard Krber <rkoerber@gmx.de>
 */



#ifndef STARTUP_DEFS_H
#define STARTUP_DEFS_H

#define PROGNAME        "Scout"
#define RELEASEVERSION  "2"
#define RELEASEREVISION "15"
#define AUTHOR          "A. Gelhausen, R. Krber, T. Bckelmann"
#define COPYRIGHT       "  1994-2002 " AUTHOR "  "
#define DESCRIPTION     "Systemmonitor"
#define EMAIL           "tboeckel@uni-paderborn.de"
#define URL             "http://shredzone.home.pages.de"
   
#define MYLIBVERSION       37

struct Args {
   LONG     *ToolPri;
   STRPTR   Startup;
   LONG     Iconified;
   STRPTR   PortName;
   STRPTR   IntervalTime;
   LONG     *CpuDisplay;
   STRPTR   Host;
   STRPTR   User;
   STRPTR   Password;
   LONG     SingleWindows;
   LONG     *SortLibrariesType;
   LONG     *SortDevicesType;
   LONG     *SortResourcesType;
   LONG     *SortTasksType;
   LONG     *SortPortsType;
   LONG     *SortCommandsType;
   LONG     *SortAssignsType;
   LONG     *SortLocksType;
   LONG     *SortCommoditiesType;
   LONG     *SortScreenmodeType;
   LONG     *SortClassesType;
   STRPTR   Command;
};

#define WBTEMPLATE      "TOOLPRI/K/N,STARTUP/K,ICONIFIED/S,PORTNAME/K," \
                        "INTERVALTIME/K,CPUDISPLAY/K/N," \
                        "HOST/K,USER/K,PASSWORD/K," \
                        "SW=SINGLEWINDOWS/S," \
                        "SORTLIBRARIESTYPE/K/N,SORTDEVICESTYPE/K/N,SORTRESOURCESTYPE/K/N," \
                        "SORTTASKSTYPE/K/N,SORTPORTSTYPE/K/N,SORTCOMMANDSTYPE/K/N," \
                        "SORTASSIGNSTYPE/K/N,SORTLOCKSTYPE/K/N,SORTCOMMODITIESTYPE/K/N," \
                        "SORTSCREENMODETYPE/K/N,SORTCLASSESTYPE/K/N," \
                        "C=COMMAND/K"

#define TEMPLATE        "TOOLPRI/K/N,STARTUP/K,ICONIFIED/S,PORTNAME/K," \
                        "INTERVALTIME/K,CPUDISPLAY/K/N," \
                        "HOST/K,USER/K,PASSWORD/K," \
                        "SW=SINGLEWINDOWS/S," \
                        "SORTLIBRARIESTYPE/K/N,SORTDEVICESTYPE/K/N,SORTRESOURCESTYPE/K/N," \
                        "SORTTASKSTYPE/K/N,SORTPORTSTYPE/K/N,SORTCOMMANDSTYPE/K/N," \
                        "SORTASSIGNSTYPE/K/N,SORTLOCKSTYPE/K/N,SORTCOMMODITIESTYPE/K/N," \
                        "SORTSCREENMODETYPE/K/N,SORTCLASSESTYPE/K/N," \
                        "C=COMMAND/K"

#define OPT_COUNT       sizeof(struct Args)/sizeof(LONG)


#endif /* STARTUP_DEFS_H */
