/*
 * $Id: system_headers.h,v 1.3 2002/02/13 13:46:05 tboeckel Exp $
 *
 * :ts=4
 *
 * SMB file system wrapper for AmigaOS, using the AmiTCP V3 API
 *
 * Copyright (C) 2000 by Olaf `Olsen' Barthel <olsen@sourcery.han.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _SYSTEM_HEADERS_H
#define _SYSTEM_HEADERS_H 1

#define __USE_SYSBASE

/*****************************************************************************/

#define NULL ((APTR)0L)
#include <exec/types.h>

/*****************************************************************************/

#define USE_BUILTIN_MATH 1
#include <string.h>

/*****************************************************************************/

#include <exec/types.h>
#include <exec/execbase.h>
#include <exec/tasks.h>
#include <exec/memory.h>
#include <exec/alerts.h>
#include <exec/ports.h>
#include <exec/libraries.h>
#include <exec/semaphores.h>
#include <exec/resident.h>
#include <dos/datetime.h>
#include <dos/dos.h>
#include <dos/filehandler.h>
#include <dos/dosextens.h>
#include <dos/rdargs.h>
#include <dos/dosasl.h>
#include <graphics/gfxbase.h>
#include <graphics/gfxmacros.h>
#include <graphics/gfx.h>
#include <graphics/gfxnodes.h>
#include <graphics/displayinfo.h>
#include <graphics/monitor.h>
#include <graphics/layers.h>
#include <intuition/intuitionbase.h>
#include <intuition/intuition.h>
#include <intuition/screens.h>
#include <intuition/sghooks.h>
#include <devices/ahi.h>
#include <devices/audio.h>
#include <devices/cd.h>
#include <devices/clipboard.h>
#include <devices/console.h>
#include <devices/gameport.h>
#include <devices/input.h>
#include <devices/keyboard.h>
#include <devices/parallel.h>
#include <devices/printer.h>
#include <devices/sana2.h>
#include <devices/scsidisk.h>
#include <devices/serial.h>
#include <devices/timer.h>
#include <devices/trackdisk.h>
#include <devices/newstyle.h>
#include <libraries/configvars.h>
#include <libraries/commodities.h>
#include <libraries/commodities_private.h>
#include <libraries/expansion.h>
#include <libraries/expansionbase.h>
#include <libraries/identify.h>
#include <libraries/usergroup.h>
#include <libraries/mui.h>
#include <rexx/rxslib.h>
#include <resources/misc.h>
#include <resources/cia.h>
#include <resources/filesysres.h>
#include <resources/card.h>
#include <resources/disk.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/syslog.h>
#include <sys/time.h>
#include <utility/utility.h>
#include <utility/tagitem.h>
#include <workbench/icon.h>
#include <workbench/startup.h>
#include <workbench/workbench.h>
#include <netinet/in.h>

#include <clib/alib_protos.h>
#include <proto/asl.h>
#include <proto/cia.h>
#include <proto/diskfont.h>
#include <proto/dos.h>
#include <proto/exec.h>
#include <proto/expansion.h>
#include <proto/gadtools.h>
#include <proto/graphics.h>
#include <proto/icon.h>
#include <proto/identify.h>
#include <proto/layers.h>
#include <proto/commodities.h>
#include <proto/intuition.h>
#include <proto/muimaster.h>
#include <proto/rexxsyslib.h>
#include <proto/usergroup.h>
#include <proto/utility.h>
#include <proto/misc.h>
#include <proto/timer.h>
#include <proto/socket.h>

#include <dos.h>
#include <ctype.h>
#include <netdb.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <ios1.h>

#include "scout_defs.h"
#include "scout_logo.h"
#include "scout_protos.h"
#include "scout_net_protos.h"
#include "scout_asm_protos.h"
#include "scout_allocations_protos.h"
#include "scout_extras_protos.h"
#include "scout_expansions_protos.h"
#include "scout_flags_protos.h"
#include "scout_fonts_protos.h"
#include "scout_libs_protos.h"
#include "scout_locks_protos.h"
#include "scout_interrupts_protos.h"
#include "scout_inputhandlers_protos.h"
#include "scout_residents_protos.h"
#include "scout_ports_protos.h"
#include "scout_semaphores_protos.h"
#include "scout_tasks_protos.h"
#include "scout_windows_protos.h"
#include "scout_memory_protos.h"
#include "scout_lowmemory_protos.h"
#include "scout_mount_protos.h"
#include "scout_commands_protos.h"
#include "scout_arexx_protos.h"
#include "scout_assigns_protos.h"
#include "scout_commodity_protos.h"
#include "scout_screenmode_protos.h"
#include "scout_classes_protos.h"
#include "scout_system_protos.h"
#include "scout_timer_protos.h"
#include "scout_vectors_protos.h"
#include "scout_print_protos.h"
#include "scout_version_protos.h"

#include "startup_protos.h"
#include "startup_defs.h"

#include "i64.h"
#include <tblib.h>

#include "scout_customclasses.h"
#include "fontdisplay_class.h"

#include <pragmas/identify_pragmas.h>
#include <pragmas/cia_private_pragmas.h>

/*****************************************************************************/

#endif /* _SYSTEM_HEADERS_H */
