-- Schlangenpaket
-- Autor: Norman Walter
-- Datum: 2.2.2002

-- Das Paketschema schlangenpaket stellt dem Benutzer ein
-- Warteschlangenkonzept fr einen beliebigen Datentyp zur
-- Verfgung. Aus einer Schlange werden die Elemente in der
-- Reihenfolge ihrer Ankunft wieder ausgegeben (FIFO).
-- lnge gibt die Anzahl der Elemente in einer Schlange an.
-- Der Versuch, einer leeren Schlang ein Element zu entnehmen,
-- lst die Ausnahme schlange_ist_leer aus. Intern wird eine
-- Schlange durch den geschtzten Typ schlangen_infos
-- reprsentiert. Es wird das Paket zeiger_verwaltung benutzt.


package body schlangenpaket is

use listen_verwaltung;

   procedure push (schlange : in out schlangen_infos; elem : in element) is

   begin

      if schlange.last = null
         then holen (schlange.last);
              schlange.last.all:= (elem,null);
              schlange.first:= schlange.last;
         else holen (schlange.last.nachfolger);
              schlange.last.nachfolger.all:= (elem,null);
              schlange.last:= schlange.last.nachfolger;
         end if;

         schlange.lnge:= schlange.lnge + 1;

   end push;

   procedure pop (schlange : in out schlangen_infos; elem : out element) is

   begin

      if schlange.lnge = 0 then raise schlange_ist_leer;
      end if;

      elem:= schlange.first.daten;

      aushngen:

         declare

            hilfszeiger : zeiger_typ;

            begin

               hilfszeiger:= schlange.first;
               schlange.first:= schlange.first.nachfolger;

               ablegen (hilfszeiger);

      end aushngen;

      schlange.lnge:= schlange.lnge-1;

      if schlange_leer(schlange) then schlange.last:= null;
      end if;

   end pop;

   function lnge (schlange : in schlangen_infos) return integer is

   begin
      return schlange.lnge;

   end lnge;

   function schlange_leer (schlange : in schlangen_infos) return boolean is
   -- Liefert true zurck, falls schlange leer ist, sonst false
   begin
      return schlange.lnge = 0;

   end schlange_leer;

end schlangenpaket;
